//+------------------------------------------------------------------+
//|                                   bressert double stochastic.mq4 |
//|                                                           mladen |
//| made after the prorealtim formula                                |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_color3  Orange
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_minimum 0
#property indicator_maximum 100

//
//
//
//
//

extern int                StochasticLength = 10;
extern int                SmoothEmaLength  =  3;
extern int                RatioLong        =  7;
extern int                RatioShort       =  3;
extern ENUM_APPLIED_PRICE RatioPrice       =  PRICE_CLOSE;
extern int                SellLine         = 60;
extern int                BuyLine          = 40;
double dsBuffer[];
double dsBufferda[];
double dsBufferdb[];
double slope[];


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,dsBuffer);
   SetIndexBuffer(1,dsBufferda);
   SetIndexBuffer(2,dsBufferdb);
   SetIndexBuffer(3,slope);
      StochasticLength = MathMax(1,StochasticLength);
      SmoothEmaLength  = MathMax(1,SmoothEmaLength);
         SetLevelValue(0,SellLine);
         SetLevelValue(1,BuyLine);
   IndicatorShortName("Bressert double stochastic("+StochasticLength+","+SmoothEmaLength+")");
   return(0);
}
int deinit(){ return(0); }




//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][3];
#define _st1   0
#define _ss1   1
#define _ratio 2

//
//
//
//
//

int start()
{
   int i,r,counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+SmoothEmaLength);
   if (slope[limit]==-1) CleanPoint(limit,dsBufferda,dsBufferdb);
 	for(i = limit, r=Bars-i-1; i>=0; i--,r++)
   {
      work[r][_ratio] = iMA(NULL,0,RatioShort,0,MODE_EMA,RatioPrice,i)/iMA(NULL,0,RatioLong,0,MODE_EMA,RatioPrice,i);
      double min = work[r][_ratio];
      double max = work[r][_ratio];
      for (int k=1; k<StochasticLength && (r-k)>=0; k++)
      {
         min = MathMin(min,work[r-k][_ratio]);
         max = MathMax(max,work[r-k][_ratio]);
      }
      
      work[r][_st1] = 0; if (min!=max) work[r][_st1] = 100*(work[r][_ratio]-min)/(max-min);
      work[r][_ss1] = work[r-1][_ss1]+alpha*(work[r][_st1]-work[r-1][_ss1]);

      //
      //
      //
      //
      //

      min = work[r][_ss1];
      max = work[r][_ss1];
      for (k=1; k<StochasticLength && (r-k)>=0; k++)
      {
         min = MathMin(min,work[r-k][_ss1]);
         max = MathMax(max,work[r-k][_ss1]);
      }
      double stoch = 0; if (min!=max) stoch = 100*(work[r][_ss1]-min)/(max-min);
      dsBuffer[i]   = dsBuffer[i+1]+alpha*(stoch-dsBuffer[i+1]);
      dsBufferda[i] = EMPTY_VALUE;
      dsBufferdb[i] = EMPTY_VALUE;
      slope[i]      = slope[i+1];
         if (dsBuffer[i]>dsBuffer[i+1]) slope[i] =  1;
         if (dsBuffer[i]<dsBuffer[i+1]) slope[i] = -1;
         if (slope[i]==-1) PlotPoint(i,dsBufferda,dsBufferdb,dsBuffer);
   }      
   return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}